// Copyright (C) 2003  Daniel De Graaf
// Functions 0-9 (not 7)

#include "defines.h"

Func version(FuncArgs) {
	return OneInt(17);  //version number
}

Func disp(FuncArgs) {
	ERR (*args != STR_TAG);
	ST_showHelp(GetStrnArg(args));
	return 0;
}

Func dispTxt(FuncArgs) {
	ERR (*args != STR_TAG);
	string txt = GetStrnArg(args);
	short x = GetInt(0,240);
	short y = GetInt(0,154);
	short osize = FontSetSys(OptInt(0,2,1));
	short mode = OptInt(0,4,4);
	DrawStr(x,y,txt,mode);
	FontSetSys(osize);
	return 0;
}

Func drawPxl(FuncArgs) {
	short x = GetInt(0,240);
	short y = GetInt(0,160);
	DefData(1);
	*data = GetPix(x,y) + FALSE_TAG; //TRUE_TAG if 1
	if (IsInt)
		DrawPix(x,y,GetLastInt(0,A_XOR));
	return d_h;
}

Func sprite(FuncArgs) {
	short t,h,numpts=1;
	char x[255], y[255], buffer[255];

	if (*args != LIST_TAG) {
		*x = GetInt(0,240);
		*y = GetInt(0,160);
	} else {
	//xlist
		for(t=0;*args != END_TAG && t < 255;t++)
			x[t] = GetInt(0,240);
		args--;
		numpts=t;
	//ylist
		ERR (*(args--) != LIST_TAG);
		for(t=0;*args != END_TAG && t < 255;t++)
			y[t] = GetInt(0,160);
		args--;
		if (numpts > t) numpts=t;
	}
//spritelist
	ERR (*(args--) != LIST_TAG);
	for(h=0;*args != END_TAG;h++)
		buffer[h] = GetInt(0,255);
//args--;

	for(t=0; t<numpts; t++)
		Sprite8(x[t], y[t], h, buffer, LCD_MEM, SPRT_XOR);
	return 0;
}

Func busy(FuncArgs) {
	ST_busy(GetLastInt(0,2)); 
	return 0;
}

//power is written in assembly - see asm.h

Func message(FuncArgs) {
	ERR (*args != STR_TAG);
	string title = GetStrnArg(args);
	ERR (*args != STR_TAG);
	string msg = GetStrnArg(args);
	short lb = OptInt(0,6,0);
	short rb = OptInt(0,6,0);
	short r = DlgMessage(title, msg, lb, rb);
	DefData(1);
	*data = (r == KEY_ENTER) ? TRUE_TAG : FALSE_TAG;
	return d_h;
}

Func GetHandle(FuncArgs) {
	ERR (*args != STR_TAG);
	char* name=(char*)GetSymstrArg(args);
	HSym t;
	if (args[2] == '\\') {
		char buffer[16];
		t = SymFind(FillBufWithLocalName(buffer,args+2,name));
	} else if (*(name-1) == '\\') {
		*(--name)=0;
		t = SymFindHome(name); //find a folder
	} else {
		t = SymFind(name);
	}
	ERR (!t.folder);
	SYM_ENTRY* sym=DerefSym(t);
	return OneInt(sym->handle);
}

Func Flags(FuncArgs) {
	ERR (*args != STR_TAG);
	char* name=(char*)GetSymstrArg(args);
	HSym t;
	//Flags on local variables are not useful enough to add support
	//if you really want to, use "0001\x" to access them
	if (*(name-1) == '\\') {
		*(--name)=0;
		t = SymFindHome(name); //find a folder
	} else {
		t = SymFind(name);
	}
	ERR (!t.folder);
	SYM_ENTRY* sym=DerefSym(t);
	HANDLE d_h = OneInt(sym->flags.flags_n);
	if (IsInt) sym->flags.flags_n = GetLastInt(0,0x10000);
	return d_h;
}
